//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "callback.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  char name[20];
  char model[20];
  int type;

  h = LoadLibrary("EXTIO_PMSDR.DLL");
  MainForm->Caption=AnsiString().sprintf("PMSDR Control V%s", VERSION);
  if (h==0) {
        ShowMessage("EXTIO_PMSDR.DLL not found");
        MainForm->Close();
      }
  else {
    TEdit_lo_freq->Text=7000000;
    List10MHz->ItemIndex=0;
    List1MHz->ItemIndex=7;
    List100kHz->ItemIndex=0;
    List10kHz->ItemIndex=0;
    List1kHz->ItemIndex=0;
    List100Hz->ItemIndex=0;
    List10Hz->ItemIndex=0;

    TEdit_lo_freq->Text = "PMSDR not found!";
    TInitHW* InitHW=(TInitHW*)GetProcAddress(h,"InitHW");
    if (InitHW == 0) ShowMessage("InitHW not found");
    else InitHW(name,model,type);

    MainForm->Caption=AnsiString().sprintf("PMSDR Control V%s -> %s %s", VERSION,name,model);
    //TEdit_lo_freq->Text = AnsiString().sprintf ("%3.6f MHz",(rfreq*fxtal)/(initial_hsdiv*initial_n1*4.0));


    TSetCallback* SetCallback=(TSetCallback*) GetProcAddress(h,"SetCallback");
    SetCallback(extIOCallback);

    TGetHWLO* GetHWLO=(TGetHWLO*)GetProcAddress(h,"GetHWLO");
    if (GetHWLO == 0) ShowMessage("GetHWLO not found");

    TOpenHW* OpenHW=(TOpenHW*)GetProcAddress(h,"OpenHW");
    if (OpenHW == 0) ShowMessage("OpenHW not found");
    else if (OpenHW()) {
               TShowGUI* ShowGUI=(TShowGUI*)GetProcAddress(h,"ShowGUI");
               if (ShowGUI == 0) ShowMessage("ShowGUI not found");
               else ShowGUI();

               LOfreq = 7000000;

               TStartHW* StartHW=(TStartHW*)GetProcAddress(h,"StartHW");
               if (StartHW == 0) ShowMessage("StartHW not found");
               else StartHW(LOfreq);
               TSetHWLO* SetHWLO=(TSetHWLO*)GetProcAddress(h,"SetHWLO");
               SetHWLO(LOfreq);
               TTuneChanged* TuneChanged=(TTuneChanged*)GetProcAddress(h,"TuneChanged");
               if (TuneChanged == 0) ShowMessage("TuneChanged not found");
               else TuneChanged(LOfreq);
               TEdit_lo_freq->Text = AnsiString().sprintf ("%003.5f MHz",(float)(LOfreq/1000000.0));
          }
     }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (h){
     TStopHW* StopHW=(TStopHW*)GetProcAddress(h,"StopHW");
     if (StopHW == 0) ShowMessage("StopHW not found");
     else StopHW();

     TCloseHW* CloseHW=(TCloseHW*)GetProcAddress(h,"CloseHW");
     if (CloseHW == 0) ShowMessage("CloseHW not found");
     else CloseHW();

     THideGUI* HideGUI=(THideGUI*)GetProcAddress(h,"HideGUI");
     if (HideGUI == 0) ShowMessage("HideGUI not found");
     else HideGUI();
     FreeLibrary("EXTIO_PMSDR.DLL");
     }
}

//---------------------------------------------------------------------------


void __fastcall TMainForm::TEdit_lo_freqEnter(TObject *Sender)
{
        //AnsiString t = TEdit_lo_freq->Text;
       // t=t.SubString(1,t.Pos(' ')-1);
        //t.Trim();
        //t.Delete(t.Pos(','),1);
        //t.TrimRight();
        LOfreq=( List10MHz->ItemIndex * 10000000 + List1MHz->ItemIndex * 1000000 + List100kHz->ItemIndex * 100000);
        LOfreq+=( List10kHz->ItemIndex * 10000 + List1kHz->ItemIndex * 1000 + List100Hz->ItemIndex * 100 + List10Hz->ItemIndex * 10);

        TEdit_lo_freq->Text = AnsiString().sprintf ("%003.5f MHz",(float)(LOfreq/1000000.0));
        TSetHWLO* SetHWLO=(TSetHWLO*)GetProcAddress(h,"SetHWLO");
        if (SetHWLO == 0) ShowMessage("SetHWLO not found");
        else SetHWLO(LOfreq);
        TTuneChanged* TuneChanged=(TTuneChanged*)GetProcAddress(h,"TuneChanged");
        if (TuneChanged == 0) ShowMessage("TuneChanged not found");
        else TuneChanged(LOfreq);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::List10MHzMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        //freq=( List10MHz->ItemIndex * 10000000 + List1MHz->ItemIndex * 1000000 + List100kHz->ItemIndex * 100000);
        if (LOfreq<=90000000)LOfreq+=10000000 ;
        TEdit_lo_freq->Text = AnsiString().sprintf ("%003.5f MHz",(float)(LOfreq/1000000.0));
        TSetHWLO* SetHWLO=(TSetHWLO*)GetProcAddress(h,"SetHWLO");
        if (SetHWLO == 0) ShowMessage("SetHWLO not found");
        else SetHWLO(LOfreq);
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::List10MHzMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
       //freq=( List10MHz->ItemIndex * 10000000 + List1MHz->ItemIndex * 1000000 + List100kHz->ItemIndex * 100000);
        if (LOfreq>=10000000)LOfreq-=10000000 ;
        TEdit_lo_freq->Text = AnsiString().sprintf ("%003.5f MHz",(float)(LOfreq/1000000.0));
        TSetHWLO* SetHWLO=(TSetHWLO*)GetProcAddress(h,"SetHWLO");
        if (SetHWLO == 0) ShowMessage("SetHWLO not found");
        else SetHWLO(LOfreq);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::List10MHzMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
       if (LOfreq>=10000000)LOfreq-=10000000 ;
        TEdit_lo_freq->Text = AnsiString().sprintf ("%003.5f MHz",(float)(LOfreq/1000000.0));
        TSetHWLO* SetHWLO=(TSetHWLO*)GetProcAddress(h,"SetHWLO");
        if (SetHWLO == 0) ShowMessage("SetHWLO not found");
        else SetHWLO(LOfreq);
}
//---------------------------------------------------------------------------



